import inspect


class Handler:
    def __init__(self):
        self.handlers = {}

    def __call__(self):
        def annotate(method):
            spec = inspect.getfullargspec(method)
            assert len(spec.args) == 1 and spec.varargs is None

            self.handlers[spec.annotations[spec.args[0]]] = method

        return annotate

    def __getitem__(self, key):
        return self.handlers[key.__class__](key)
